#!/afs/cern.ch/user/r/rtomas/lintrack/Python-2.5_32bit/Python-2.5_32bit/bin/python

import sys
from numpy import *
import os
import string
from math import *
import random
from mapclassGaussianDelta25 import *


def RMS():

# for RMS evaluation
    betx=8.62817146
    bety=0.718388011
    gamma=2544.0313111546
    ex=5.08e-6
    ey=3e-8
    sigmaFFS=[sqrt(ex*betx/gamma), sqrt(ex/betx/gamma), sqrt(ey*bety/gamma), sqrt(ey/bety/gamma), 0.0008]
    file='fort.18'
    map=Map(5,file)
    sigmay5=sqrt(map.sigma('y',sigmaFFS)-map.offset('y',sigmaFFS)**2)
    print "sigmay5=",sqrt(map.sigma('y',sigmaFFS)-map.offset('y',sigmaFFS)**2)
    return sigmay5

def Shintake():

#  laser properties: crossing mode 174  lambda= 532e-9 measurement range [18nm - 90nm]
    teta=math.radians(174)
    lamda=532e-9
    d=lamda/(2*math.sin(teta/2))
# d (174)=266 nm
    k=2*math.pi/d
    la=open('laser','w')
    ll=open('conv','w')
    bb=open('beam','w')
    fy=open('start_fit','w')
    num=30*200
    ydy=d/200
    I=[]
    y=0
#for M in range (9):
#    print (M+1)*0.1,d/(2*math.pi)*sqrt(2*math.log(abs(math.cos(teta))/((M+1)*0.1)))
#print lamda,teta,d,k,1+cos(teta)*cos(k*y)
#os.exit()

    ext="trackone"
    running=True
    l=0
    y_val=[]
    for line in open(ext):
        sline=line.split()
        if len(sline)>8:
            if sline[1]=='1': 
                y_val.append(float(sline[4]))
                l+=1
            else : l+=1
    ymin=min(y_val)
    ymax=max(y_val)
    num2=int((ymax-ymin)/ydy)+2
    conv=500
    for f in range(num2+conv):
        y+=ydy
        I.append(1+cos(teta)*cos(k*y))
        print >>la,y,I[f]
    la.close()

# J describes the histogram of particles

    i=0
    J=zeros((num2),float)
    for val in y_val:
        while running:
            if val <=ymin+ydy*i:
                J[i]+=1
                i=0
                running=False
            else: i+=1
        running=True
        i=0
#convolution        ymin+=ydy
    N=zeros((conv),float)
    for i in range(conv):
        for j in range(num2):
            N[i]+=I[j+i]*J[j]
        print >> ll,N[i]
    ll.close()
        
    nmax=max(N[:])
    nmin=min(N[:])
    M=(nmax-nmin)/(nmax+nmin)
    sigmay_shy=d/(2*math.pi)*sqrt(2*math.log(abs(math.cos(teta))/M))
    print 'sigmay (Shintake)=',sigmay_shy,'    ;'
    
    return sigmay_shy

def CORE():
    teta=math.radians(174)
    lamda=532e-9
    d=lamda/(2*math.sin(teta/2))
    num=16*20
    ydy=16*d/num
    bb=open('beam','w')
    fy=open('start_fit','w')
    I=[]
    y=0
    ext="trackone"
    running=True
    l=0
    y_val=[]
    x_val=[]
    for line in open(ext):
        sline=line.split()
        if len(sline)>8:
            if sline[1]=='1': 
                x_val.append(float(sline[2]))
                y_val.append(float(sline[4]))
                l+=1
            else : l+=1
    print 'sigma_x rms =' ,std(x_val)
    print 'sigma_y rms =' ,std(y_val)
    ymin=min(y_val)
    ymax=max(y_val)
    num2=int((ymax-ymin)/ydy)+2

# J describes the histogram of particles

    i=0
    J=zeros((num2),float)
    for val in y_val:
        while running:
            if val <=ymin+ydy*i:
                J[i]+=1
                i=0
                running=False
            else: i+=1
        running=True
        i=0
    for i in J:
        if i>=5:
            print >>bb,ymin*1e9,i
            ymin+=ydy
        else: ymin+=ydy
    bb.close()
    ct=min(y_val)
    for i in J:
        if i==max(J[:]):
            break
        else: ct+=ydy
    print >> fy,"a0=",max(J[:])
    print >> fy,"t0=",std(y_val)*1e9
    print >> fy,"x0=",ct*1e9
    fy.close()
    os.system("gnuplot gph_gaussy")
    os.system("grep . fit.log > fit")
    t=0
    for line in open('fit'):
        sline=line.split()
        if sline[0]=='Final':
            t=1
        if t==1 and sline[0]=='t0':
            sigmay_core=float(sline[2])*1e-9
            break
        else: continue
    os.system("rm fit*")
    print 'sigmay (core)=',sigmay_core,'   ;'
    
    return sigmay_core
